within ;
package HeartVentricle
  class References "References"
    extends Modelica.Icons.References;

    annotation (Documentation(info="<html>
<table cellspacing=\"2\" cellpadding=\"0\" border=\"0\"><tr>
<td><p>[Braunwald1976]</p></td>
<td><p>E. Braunwald, J. Ross, and E. H. Sonnenblick, Mechanisms of contraction of the normal and failing heart: Little, Brown Boston, 1976. </p></td>
</tr>
<tr>
<td><p>[Carter1998]</p></td>
<td><p>Y. M. Carter, C. X. Jia, P. F. Soto, J. P. Starr, D. G. Rabkin, D. T. Hsu, et al., &QUOT;Diastolic properties, myocardial water content, and histologic condition of the rat left ventricle: effect of varied osmolarity of a coronary perfusate,&QUOT; The Journal of heart and lung transplantation : the official publication of the International Society for Heart Transplantation, vol. 17, pp. 140-149, 1998/02// 1998. </p></td>
</tr>
<tr>
<td><p>[Gaasch1975]</p></td>
<td><p>W. H. Gaasch, J. S. Cole, M. A. Quinones, and J. Alexander, &QUOT;Dynamic determinants of letf ventricular diastolic pressure-volume relations in man,&QUOT; Circulation, vol. 51, pp. 317-323, 1975. </p></td>
</tr>
<tr>
<td><p>[Guyton1961]</p></td>
<td><p>A. C. Guyton and K. Sagawa, &QUOT;Compensations of cardiac output and other circulatory functions in areflex dogs with large AV fistulas,&QUOT; The American journal of physiology, vol. 200, p. 1157, 1961. </p></td>
</tr>
<tr>
<td><p>[MONROE1961]</p></td>
<td><p>R. G. MONROE and G. N. FRENCH, &QUOT;Left ventricular pressure-volume relationships and myocardial oxygen consumption in the isolated heart,&QUOT; Circulation research, vol. 9, pp. 362-373, 1961. </p></td>
</tr>
<tr>
<td><h4>[NODA1993]</h4></td>
<td><h4>T. NODA, C.-P. CHENG, P. P. DE TOMBE, and W. C. LITTLE, &QUOT;Curvilinearity of LV end-systolic pressure-volume and dP/dt,-end-diastolic volume relations,&QUOT; 1993. </h4></td>
</tr>
<tr>
<td><p>[Pog&aacute;tsa1982]</p></td>
<td><p>G. Pog&aacute;tsa, M. Z. Koltai, and G. Gr&oacute;sz, &QUOT;The role of the myocardial water content in heart function,&QUOT; Acta physiologica Academiae Scientiarum Hungaricae, vol. 59, pp. 305-309, 1982 1982. </p></td>
</tr>
<tr>
<td><p>[Sagawa1988]</p></td>
<td><p>K. Sagawa, L. Maughan, H. Suga, and K. Sunagawa, Cardiac contraction and the pressure-volume relationship vol. 480: Oxford University Press New York, 1988. </p></td>
</tr>
<tr>
<td><p>[SUGA1974]</p></td>
<td><p>H. SUGA and K. SAGAWA, &QUOT;Instantaneous Pressure-Volume Relationships and Their Ratio in the Excised, Supported Canine Left Ventricle,&QUOT; Circulation Research, vol. 35, pp. 117-126, July 1, 1974 1974. </p></td>
</tr>
<tr>
<td><p>[SUGA1976]</p></td>
<td><p>H. SUGA, K. SAGAWA, and D. P. KOSTIUK, &QUOT;Controls of ventricular contractility assessed by pressure-volume ratio, Emax,&QUOT; Cardiovascular Research, vol. 10, pp. 582-592, September 1, 1976 1976. </p></td>
</tr>
<tr>
<td><p>[Sugimoto1966]</p></td>
<td><p>T. Sugimoto, K. Sagawa, and A. Guyton, Effect of tachycardia on cardiac output during normal and increased venous return vol. 211, 1966. </p></td>
</tr>
<tr>
<td><p>[Woo1972]</p></td>
<td><p>S. L. Y. Woo, A. S. Kobayashi, C. Lawrence, and W. A. Schlegel, &QUOT;Mathematical model of the corneo-scleral shell as applied to intraocular pressure-volume relations and applanation tonometry,&QUOT; Annals of Biomedical Engineering, vol. 1, pp. 87-98, 1972/09/01 1972. </p></td>
</tr>
<tr>
<td><p>[Xenopoulos1994]</p></td>
<td><p>N. P. Xenopoulos and R. J. Applegate, &QUOT;The effect of vagal stimulation on left ventricular systolic and diastolic performance,&QUOT; American Journal of Physiology-Heart and Circulatory Physiology, vol. 35, p. H2167, 1994. </p></td>
</tr>
</table>
</html>"));
  end References;

  partial model HeartVentricleInterface
    extends Physiolibrary.Icons.HeartVentricle;

    Physiolibrary.Hydraulic.Interfaces.HydraulicPort_a port_a
      "From atrium (5.5 l/min, right: 0.7 mmHg, left: 4.8 mmHg)"
      annotation (Placement(transformation(extent={{-110,-10},{-90,10}}),
          iconTransformation(extent={{10,70},{30,90}})));
    Physiolibrary.Hydraulic.Interfaces.HydraulicPort_b port_b
      "To arteries (5.5 l/min, pulmonary: 13 mmHg, systemic: 96 mmHg)"
      annotation (Placement(transformation(extent={{90,-10},{110,10}}),
          iconTransformation(extent={{-30,90},{-10,110}})));

    Physiolibrary.Types.BusConnector busConnector "Group of inputs"
      annotation (Placement(transformation(extent={{-82,70},{-62,90}}),
          iconTransformation(extent={{20,-80},{60,-40}})));
    Physiolibrary.Types.RealIO.FractionInput betaReceptors
      "Normalized beta receptors activity (100%)"                                                      annotation (Placement(
          transformation(extent={{0,50},{20,70}}), iconTransformation(
          extent={{-20,-20},{20,20}},
          rotation=180,
          origin={80,40})));
    Physiolibrary.Types.RealIO.FractionInput cholinergicReceptors
      "Normalized cholinergic receptors activity (100%)" annotation (Placement(
          transformation(extent={{0,76},{20,96}}), iconTransformation(
          extent={{-20,-20},{20,20}},
          rotation=180,
          origin={80,-20})));
    annotation (Icon(coordinateSystem(preserveAspectRatio=false, extent={{-100,
              -100},{100,100}}),
                           graphics), Diagram(coordinateSystem(
            preserveAspectRatio=false, extent={{-100,-100},{100,100}}), graphics));
  end HeartVentricleInterface;

  model Inputs "Example of subsystem inputs"
   //  extends Physiolibrary.Types.IO_Bus.InputFromFile;
   import T = Physiolibrary.Types.RealTypeInputParameters;

    T.Frequency HeartRate(varName="SANode-Rate.Rate", k=1.25) "Heart rate "
      annotation (Placement(transformation(extent={{-80,24},{2,106}})));
    T.Pressure PericardiumPressure(varName="Pericardium-Cavity.Pressure", k=-439.9638784695)
      "Pericardium pressure"
    annotation (Placement(transformation(extent={{-80,-6},{2,76}})));

    Physiolibrary.Types.RealIO.FractionOutput LeftHeartBetaReceptors annotation (
        Placement(transformation(extent={{100,-10},{120,10}}),
          iconTransformation(extent={{100,-10},{120,10}})));
    Physiolibrary.Types.RealIO.FractionOutput RightHeartBetaReceptors annotation (
       Placement(transformation(extent={{100,-40},{120,-20}}), iconTransformation(
            extent={{100,-40},{120,-20}})));
    T.Fraction LeftHeartBetaReceptorsActivity(varName="LeftHeart-BetaReceptors.Activity", k=1)
      "Normalized Left Heart Beta-Receptors Activity"
      annotation (Placement(transformation(extent={{-80,-40},{0,40}})));
    T.Fraction RightHeartBetaReceptorsActivity(varName="RightHeart-BetaReceptors.Activity", k=1)
      "Normalized Right Heart Beta-Receptors Activity"
      annotation (Placement(transformation(extent={{-80,-68},{0,12}})));
    Physiolibrary.Types.BusConnector
                 busConnector annotation (Placement(transformation(extent={{90,38},
              {110,58}}),        iconTransformation(extent={{90,70},{110,90}})));
    T.Fraction LeftHeartCholinergicReceptorsActivity(varName="LeftHeart-CholinergicReceptors.Activity",
        k=1) "Normalized Left Heart Cholinergic-Receptors Activity"
      annotation (Placement(transformation(extent={{10,-90},{50,-50}})));
    T.Fraction RightHeartCholinergicReceptorsActivity(varName="RightHeart-CholinergicReceptors.Activity",
        k=1) "Normalized Right Heart Cholinergic-Receptors Activity"
      annotation (Placement(transformation(extent={{10,-112},{50,-66}})));
    Physiolibrary.Types.RealIO.FractionOutput LeftHeartCholinergicReceptors
      annotation (Placement(transformation(extent={{100,-70},{120,-50}}),
          iconTransformation(extent={{100,-10},{120,10}})));
    Physiolibrary.Types.RealIO.FractionOutput RightHeartCholinergicReceptors
      annotation (Placement(transformation(extent={{100,-100},{120,-80}}),
          iconTransformation(extent={{100,-50},{120,-30}})));
    T.Concentration Dobutamine(varName="Dobutamine", k=1)
      "Dobutamine alters contractility"
      annotation (Placement(transformation(extent={{16,-6},{56,34}})));
  equation
    connect(HeartRate.y, busConnector.HeartVentricleRate) annotation (Line(
        points={{12.25,65},{74,65},{74,48},{100,48}},
        color={0,0,127},
        smooth=Smooth.None), Text(
        string="%second",
        index=1,
        extent={{6,3},{6,3}}));
    connect(PericardiumPressure.y, busConnector.Pericardium_Pressure) annotation (
       Line(
        points={{12.25,35},{74,35},{74,48},{100,48}},
        color={0,0,127},
        smooth=Smooth.None), Text(
        string="%second",
        index=1,
        extent={{6,3},{6,3}}));
    connect(LeftHeartBetaReceptorsActivity.y, LeftHeartBetaReceptors) annotation (
       Line(
        points={{10,0},{110,0}},
        color={0,0,127},
        smooth=Smooth.None));
    connect(RightHeartBetaReceptorsActivity.y, RightHeartBetaReceptors)
      annotation (Line(
        points={{10,-28},{60,-28},{60,-30},{110,-30}},
        color={0,0,127},
        smooth=Smooth.None));
    connect(LeftHeartCholinergicReceptorsActivity.y,
      LeftHeartCholinergicReceptors) annotation (Line(
        points={{55,-70},{64,-70},{64,-60},{110,-60}},
        color={0,0,127},
        smooth=Smooth.None));
    connect(RightHeartCholinergicReceptorsActivity.y,
      RightHeartCholinergicReceptors) annotation (Line(
        points={{55,-89},{64,-89},{64,-90},{110,-90}},
        color={0,0,127},
        smooth=Smooth.None));
    connect(Dobutamine.y, busConnector.Dobutamine) annotation (Line(
        points={{61,14},{82,14},{82,48},{100,48}},
        color={0,0,127},
        smooth=Smooth.None), Text(
        string="%second",
        index=1,
        extent={{6,3},{6,3}}));
    annotation (experiment(StopTime=1), Diagram(coordinateSystem(
            preserveAspectRatio=false, extent={{-100,-100},{100,100}}), graphics),
      Icon(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},{100,100}}),
          graphics));
  end Inputs;
  annotation (uses(Physiolibrary(version="2.2.0"), Modelica(version=
            "3.2.1")));
end HeartVentricle;
